Bug 1376035 - Review Request: modulemd - Module metadata manipulation library
Summary: Review Request: modulemd - Module metadata manipulation library
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Parag AN(पराग)
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-09-14 13:21 UTC by Miroslav Suchý
Modified: 2016-12-07 16:19 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2016-12-01 15:54:58 UTC
Type: ---
panemade: fedora-review+


Attachments (Terms of Use)

Description Miroslav Suchý 2016-09-14 13:21:25 UTC
Spec URL: http://miroslav.suchy.cz/fedora/modulemd.spec
SRPM URL: http://miroslav.suchy.cz/fedora/modulemd-0-11.fc26.src.rpm
Description: Module metadata manipulation library, including modlint and python library.
Fedora Account System Username: msuchy

Comment 1 Parag AN(पराग) 2016-09-14 15:49:02 UTC
1) Python packaging guidelines recommends usage of macros
%{?python_provide:%python_provide python2-%{name}}
%{?python_provide:%python_provide python3-%{name}}

Can they be not used in this package spec? See https://fedoraproject.org/wiki/Packaging:Python#Example_common_spec_file


2) I see version in setup.py as "0.1". I think this package should use version as 0.1

3) tarball can be generated using "python setup.py sdist". As upstream not released yet any tarball, can modulemd-0.1.tar.gz be used here? Just add in comment how this tarball is generated.

3) URL should be https://pagure.io/modulemd

Comment 2 Petr Šabata 2016-09-14 16:21:32 UTC
(In reply to Parag AN(पराग) from comment #1)
> 1) Python packaging guidelines recommends usage of macros
> %{?python_provide:%python_provide python2-%{name}}
> %{?python_provide:%python_provide python3-%{name}}
>
> Can they be not used in this package spec? See
> https://fedoraproject.org/wiki/Packaging:Python#Example_common_spec_file

I had some mysterious issues with these in COPR, IIRC.
I don't know if it's still the case.

> 2) I see version in setup.py as "0.1". I think this package should use
> version as 0.1
> 
> 3) tarball can be generated using "python setup.py sdist". As upstream not
> released yet any tarball, can modulemd-0.1.tar.gz be used here? Just add in
> comment how this tarball is generated.

This is still a pre-release quality code.

We can do some quick tweaks and do an official release if Miroslav wants this in Fedora already.  The specification is still evolving and we break API every now and then, though...

> 3) URL should be https://pagure.io/modulemd

Yes, it should :)

Comment 3 Parag AN(पराग) 2016-09-15 05:11:09 UTC
(In reply to Petr Šabata from comment #2)
> (In reply to Parag AN(पराग) from comment #1)
> > 1) Python packaging guidelines recommends usage of macros
> > %{?python_provide:%python_provide python2-%{name}}
> > %{?python_provide:%python_provide python3-%{name}}
> >
> > Can they be not used in this package spec? See
> > https://fedoraproject.org/wiki/Packaging:Python#Example_common_spec_file
> 
> I had some mysterious issues with these in COPR, IIRC.
> I don't know if it's still the case.

afaics, current modulemd.spec and using the python_provide macros is giving same provides results on python2-modulemd and python3-modulemd subpackages

> 
> > 2) I see version in setup.py as "0.1". I think this package should use
> > version as 0.1
> > 
> > 3) tarball can be generated using "python setup.py sdist". As upstream not
> > released yet any tarball, can modulemd-0.1.tar.gz be used here? Just add in
> > comment how this tarball is generated.
> 
> This is still a pre-release quality code.
> 
> We can do some quick tweaks and do an official release if Miroslav wants
> this in Fedora already.  The specification is still evolving and we break
> API every now and then, though...

Whichever way is chosen can we have some steps added to generate the tarball to try to verify its checksum.

 
> > 3) URL should be https://pagure.io/modulemd
> 
> Yes, it should :)

Submitted PR https://pagure.io/modulemd/pull-request/14 ;-)


4) One more thing as this package is python providing module let's name it according to https://fedoraproject.org/wiki/Packaging:Naming#Python_source_package_naming as python-modulemd.

5) %autosetup can be used instead "%setup -q"

6) Subpackage modlint is missing Requires: python3-modulemd

Comment 4 Petr Šabata 2016-09-16 11:58:37 UTC
Thanks for the feedback, I'll reflect it in the SPEC file at some point.

@Miroslav, I'd actually vote for postponing official packaging until there's a stable release with a stable API.  That might happen once we decide how to proceed with the module versioning changes we discussed at Flock.

Comment 5 Miroslav Suchý 2016-09-19 11:01:52 UTC
(In reply to Petr Šabata from comment #4)
> @Miroslav, I'd actually vote for postponing official packaging until there's
> a stable release with a stable API.  That might happen once we decide how to
> proceed with the module versioning changes we discussed at Flock.

Copr-frontend already use python-modulemd and right now there is broken dependency. So I want to have it in Fedora as soon as possible.

Comment 6 Petr Šabata 2016-09-27 15:32:13 UTC
I'll incorporate some long-planned changes and do a proper "1.0" release within the next week or two.  This will break the API and will affect COPR (among other things), so we'll discuss it some more.

Comment 7 Petr Šabata 2016-11-07 13:44:25 UTC
Just released the first stable release.
https://pypi.python.org/pypi/modulemd/1.0.0

Note this is incompatible with the development releases that COPR probably relies on.

Comment 8 Petr Šabata 2016-11-08 13:20:10 UTC
1.0.1 released :)

Comment 10 Parag AN(पराग) 2016-11-16 06:45:06 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Few things I want to note here

1) python_provide macro is not used which I think is available on all Fedora as well as EPEL6+

2) with the new upstream release I can't see modlint now

3) I don't know why following macros are need to be explicitly added to spec file which are already available by python2-rpm-macros package.
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?py2_build: %global py2_build %{expand: CFLAGS="%{optflags}" %{__python2} setup.py %{?py_setup_args} build --executable="%{__python2} -s"}}
%{!?py2_install: %global py2_install %{expand: CFLAGS="%{optflags}" %{__python2} setup.py %{?py_setup_args} install -O1 --skip-build --root %{buildroot}}}

4) there should be some uniformity needed for python2 and python3 macros. I see above 3 lines are defined in spec file for python2 but the same is not there for python3.

I think as python2/3 macros are already available, good to drop them from spec file.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "Unknown or generated". 14 files have
     unknown license. Detailed output of licensecheck in
     /home/parag/1376035-modulemd/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 40960 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python2-modulemd , python3-modulemd
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python2-modulemd-1.0.2-1.fc26.noarch.rpm
          python3-modulemd-1.0.2-1.fc26.noarch.rpm
          modulemd-1.0.2-1.fc26.src.rpm
python2-modulemd.noarch: W: spelling-error Summary(en_US) metadata -> meta data, meta-data, metatarsal
python2-modulemd.noarch: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
python3-modulemd.noarch: W: spelling-error Summary(en_US) metadata -> meta data, meta-data, metatarsal
python3-modulemd.noarch: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
modulemd.src: W: spelling-error Summary(en_US) metadata -> meta data, meta-data, metatarsal
modulemd.src: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
3 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (installed packages)
----------------------------
python3-modulemd.noarch: W: spelling-error Summary(en_US) metadata -> meta data, meta-data, metatarsal
python3-modulemd.noarch: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
python2-modulemd.noarch: W: spelling-error Summary(en_US) metadata -> meta data, meta-data, metatarsal
python2-modulemd.noarch: W: spelling-error %description -l en_US metadata -> meta data, meta-data, metatarsal
2 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
python3-modulemd (rpmlib, GLIBC filtered):
    python(abi)
    python3-PyYAML

python2-modulemd (rpmlib, GLIBC filtered):
    PyYAML
    python(abi)



Provides
--------
python3-modulemd:
    python3-modulemd
    python3.5dist(modulemd)
    python3dist(modulemd)

python2-modulemd:
    python-modulemd
    python2-modulemd
    python2.7dist(modulemd)
    python2dist(modulemd)



Source checksums
----------------
https://files.pythonhosted.org/packages/source/m/modulemd/modulemd-1.0.2.tar.gz :
  CHECKSUM(SHA256) this package     : e5d82f908d8c877478ea786235a9632ecc4a11b3b012a70926b77efa564adf2d
  CHECKSUM(SHA256) upstream package : e5d82f908d8c877478ea786235a9632ecc4a11b3b012a70926b77efa564adf2d


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1376035 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64

APPROVED.

Comment 11 Miroslav Suchý 2016-11-16 08:55:45 UTC
(In reply to Parag AN(पराग) from comment #10)
> Few things I want to note here
> 
> 1) python_provide macro is not used which I think is available on all Fedora
> as well as EPEL6+

As of today on Fedora 25:
$ rpm --eval '%python_provide foo'
%python_provide: ERROR: foo not recognized.

I will add it there later when it will actually work.

> 2) with the new upstream release I can't see modlint now

???
 
> 3) I don't know why following macros are need to be explicitly added to spec
> file which are already available by python2-rpm-macros package.
> %{!?__python2: %global __python2 /usr/bin/python2}
> %{!?py2_build: %global py2_build %{expand: CFLAGS="%{optflags}" %{__python2}
> setup.py %{?py_setup_args} build --executable="%{__python2} -s"}}
> %{!?py2_install: %global py2_install %{expand: CFLAGS="%{optflags}"
> %{__python2} setup.py %{?py_setup_args} install -O1 --skip-build --root
> %{buildroot}}

OK. I will check it if it is available in EPEL too and will work with upstream on removal  when it make sense.
 
> 4) there should be some uniformity needed for python2 and python3 macros. I
> see above 3 lines are defined in spec file for python2 but the same is not
> there for python3.

I suppose that is because of EPEL (and I do not create python3 subpackage there, so just python2 variants). I just checked it and those macros are even available in EPEL6. So I will create PR for upstream and will remove it there.
 

> APPROVED.

Thank you.

Comment 12 Parag AN(पराग) 2016-11-16 09:21:04 UTC
(In reply to Miroslav Suchý from comment #11)
 
> I will add it there later when it will actually work.
> 
> > 2) with the new upstream release I can't see modlint now
> 
> ???
>  

Just looked into modulemd commits and found its moved to its own project https://pagure.io/modlint and then modulemd 1.0.2 tarball is released.

See https://pagure.io/modulemd/c/6bd924a7cb07bb756f47557352a7a4e562832a98?branch=master

Comment 13 Gwyn Ciesla 2016-11-16 13:31:39 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/modulemd

Comment 14 Fedora Update System 2016-11-18 08:32:33 UTC
modulemd-1.0.2-1.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2016-b3a627bbae

Comment 15 Fedora Update System 2016-11-18 08:32:42 UTC
modulemd-1.0.2-1.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2016-a749e2d8e4

Comment 16 Fedora Update System 2016-11-18 08:32:48 UTC
modulemd-1.0.2-1.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-7bf4bd5611

Comment 17 Fedora Update System 2016-11-18 08:32:53 UTC
modulemd-1.0.2-1.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2016-7c6969bdc6

Comment 18 Fedora Update System 2016-11-19 07:51:26 UTC
modulemd-1.0.2-1.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-7bf4bd5611

Comment 19 Fedora Update System 2016-11-19 08:56:26 UTC
modulemd-1.0.2-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-7c6969bdc6

Comment 20 Fedora Update System 2016-11-19 18:50:21 UTC
modulemd-1.0.2-1.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-a749e2d8e4

Comment 21 Fedora Update System 2016-11-21 21:10:34 UTC
modulemd-1.0.2-1.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-b3a627bbae

Comment 22 Fedora Update System 2016-12-01 15:54:58 UTC
modulemd-1.0.2-1.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.

Comment 23 Fedora Update System 2016-12-03 03:20:52 UTC
modulemd-1.0.2-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 24 Fedora Update System 2016-12-03 10:56:29 UTC
modulemd-1.0.2-1.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 25 Fedora Update System 2016-12-07 16:19:42 UTC
modulemd-1.0.2-1.el7 has been pushed to the Fedora EPEL 7 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.